//
//  NEXWeather.h
//  NumberEightCompiled
//
//  Created by Oliver Kocsis on 19/06/2018.
//  Copyright © 2018 NumberEight Technologies Ltd. All rights reserved.
//
#pragma once

#import "NEWeather.h"
#import "NEXSensorItem.h"

NS_ASSUME_NONNULL_BEGIN

/**
 * A representation of weather, comprising semantic temperature and conditions.
 *
 * The temperature is relative to the user's expectations: 15C is warm for Iceland, but cold for
 * Ethiopia. The conditions are an abstracted representation of the weather summary.
 */
@interface NEXWeather : NEXSensorItem

/**
 * Default constructor.
 */
- (instancetype)init;

/**
 * Default constructor.
 */
+ (instancetype)new;

/**
 * Conversion copy constructor.
 * @param weather NEWeather to copy from.
 */
- (instancetype)initWithWeather:(NEWeather)weather;

/**
 * Conversion copy constructor.
 * @param weather NEWeather to copy from.
 * @param confidence An optional confidence level from 0.0 (min) to 1.0 (max).
 */
- (instancetype)initWithWeather:(NEWeather)weather confidence:(double)confidence;

/**
 * @param temperature Temperature to assume.
 * @param conditions Conditions to assume.
 */
- (instancetype)initWithTemperature:(NEWeatherTemperature)temperature
                         conditions:(NEWeatherConditions)conditions;

/**
 * @param temperature Temperature to assume.
 * @param conditions Conditions to assume.
 * @param confidence An optional confidence level from 0.0 (min) to 1.0 (max).
 */
- (instancetype)initWithTemperature:(NEWeatherTemperature)temperature
                         conditions:(NEWeatherConditions)conditions
                         confidence:(double)confidence;

/**
 * Parse a string in serialized form.
 * @param string The serialized string, as generated by serialize()
 *
 * @return `nil` if unserialization failed.
 */
+ (instancetype _Nullable)unserializeWithString:(NSString*)string;

@property(nonatomic, readonly) NEWeather value DEPRECATED_ATTRIBUTE;

/**
 * A temperature relative to the user's expectations.
 */
@property(nonatomic, readwrite) NEWeatherTemperature temperature;

/**
 * An abstract representation of weather summary.
 */
@property(nonatomic, readwrite) NEWeatherConditions conditions;

+ (NSString*)stringFromTemperature:(NEWeatherTemperature)temperature;
+ (NSString*)stringFromConditions:(NEWeatherConditions)conditions;

/**
 * @return A hash value representing the state of the Type.
 *          Can be used for checking equality.
 */
@property(nonatomic, readonly) NSUInteger hash;

/**
 * @return The name of the concrete value class extending NEXSensorItem.
 */
@property(nonatomic, readonly) NSString* type;

/**
 * @return A human-readable format of the held data.
 */
@property(nonatomic, readonly) NSString* description;

/**
 * @return A machine-readable format of the held data.  Returns `nil` if @p type is invalid, or if
 * serialization failed.
 */
- (NSString* _Nullable)serialize;

/**
 * Strict equality comparison.
 *
 * @see NEWeather_isEqual
 *
 * @param object Value to compare with.
 */
- (BOOL)isEqual:(id _Nullable)object;

/**
 * Convert the Objective-C class to a C-compatible struct.
 */
- (NEWeather)c_val;

@end
NS_ASSUME_NONNULL_END
